Index: /NEMO/trunk/cfgs/AGRIF_DEMO/EXPREF/file_def_nemo-ice.xml
===================================================================
--- /NEMO/trunk/cfgs/AGRIF_DEMO/EXPREF/file_def_nemo-ice.xml	(revision 13609)
+++ /NEMO/trunk/cfgs/AGRIF_DEMO/EXPREF/file_def_nemo-ice.xml	(revision 13610)
@@ -52,7 +52,6 @@
        <field field_ref="normstr"          name="normstr" />
        <field field_ref="sheastr"          name="sheastr" />
-       <field field_ref="isig1"            name="isig1"   />
-       <field field_ref="isig2"            name="isig2"   />
-       <field field_ref="isig3"            name="isig3"   />
+       <field field_ref="sig1_pnorm"       name="sig1_pnorm"/>
+       <field field_ref="sig2_pnorm"       name="sig2_pnorm"/>
        
        <!-- heat fluxes -->
Index: /NEMO/trunk/cfgs/ORCA2_ICE_ABL/EXPREF/file_def_nemo-ice.xml
===================================================================
--- /NEMO/trunk/cfgs/ORCA2_ICE_ABL/EXPREF/file_def_nemo-ice.xml	(revision 13609)
+++ /NEMO/trunk/cfgs/ORCA2_ICE_ABL/EXPREF/file_def_nemo-ice.xml	(revision 13610)
@@ -53,7 +53,6 @@
        <field field_ref="normstr"          name="normstr" />
        <field field_ref="sheastr"          name="sheastr" />
-       <field field_ref="isig1"            name="isig1"   />
-       <field field_ref="isig2"            name="isig2"   />
-       <field field_ref="isig3"            name="isig3"   />
+       <field field_ref="sig1_pnorm"       name="sig1_pnorm"/>
+       <field field_ref="sig2_pnorm"       name="sig2_pnorm"/>
        
        <!-- heat fluxes -->
Index: /NEMO/trunk/cfgs/ORCA2_ICE_PISCES/EXPREF/file_def_nemo-ice.xml
===================================================================
--- /NEMO/trunk/cfgs/ORCA2_ICE_PISCES/EXPREF/file_def_nemo-ice.xml	(revision 13609)
+++ /NEMO/trunk/cfgs/ORCA2_ICE_PISCES/EXPREF/file_def_nemo-ice.xml	(revision 13610)
@@ -53,7 +53,6 @@
        <field field_ref="normstr"          name="normstr" />
        <field field_ref="sheastr"          name="sheastr" />
-       <field field_ref="isig1"            name="isig1"   />
-       <field field_ref="isig2"            name="isig2"   />
-       <field field_ref="isig3"            name="isig3"   />
+       <field field_ref="sig1_pnorm"       name="sig1_pnorm"/>
+       <field field_ref="sig2_pnorm"       name="sig2_pnorm"/>
        
        <!-- heat fluxes -->
Index: /NEMO/trunk/cfgs/ORCA2_SAS_ICE/EXPREF/file_def_nemo-ice.xml
===================================================================
--- /NEMO/trunk/cfgs/ORCA2_SAS_ICE/EXPREF/file_def_nemo-ice.xml	(revision 13609)
+++ /NEMO/trunk/cfgs/ORCA2_SAS_ICE/EXPREF/file_def_nemo-ice.xml	(revision 13610)
@@ -52,7 +52,6 @@
        <field field_ref="normstr"          name="normstr" />
        <field field_ref="sheastr"          name="sheastr" />
-       <field field_ref="isig1"            name="isig1"   />
-       <field field_ref="isig2"            name="isig2"   />
-       <field field_ref="isig3"            name="isig3"   />
+       <field field_ref="sig1_pnorm"       name="sig1_pnorm"/>
+       <field field_ref="sig2_pnorm"       name="sig2_pnorm"/>
        
        <!-- heat fluxes -->
Index: /NEMO/trunk/cfgs/SHARED/field_def_nemo-ice.xml
===================================================================
--- /NEMO/trunk/cfgs/SHARED/field_def_nemo-ice.xml	(revision 13609)
+++ /NEMO/trunk/cfgs/SHARED/field_def_nemo-ice.xml	(revision 13610)
@@ -403,7 +403,6 @@
 	  <field field_ref="normstr"          name="normstr" />
 	  <field field_ref="sheastr"          name="sheastr" />
-	  <field field_ref="isig1"            name="isig1"   />
-	  <field field_ref="isig2"            name="isig2"   />
-	  <field field_ref="isig3"            name="isig3"   />
+	  <field field_ref="sig1_pnorm"       name="sig1_pnorm"/>
+	  <field field_ref="sig2_pnorm"       name="sig2_pnorm"/>
 	  
 	  <!-- heat fluxes -->
Index: /NEMO/trunk/cfgs/SPITZ12/EXPREF/file_def_nemo-ice.xml
===================================================================
--- /NEMO/trunk/cfgs/SPITZ12/EXPREF/file_def_nemo-ice.xml	(revision 13609)
+++ /NEMO/trunk/cfgs/SPITZ12/EXPREF/file_def_nemo-ice.xml	(revision 13610)
@@ -53,7 +53,6 @@
        <field field_ref="normstr"          name="normstr" />
        <field field_ref="sheastr"          name="sheastr" />
-       <field field_ref="isig1"            name="isig1"   />
-       <field field_ref="isig2"            name="isig2"   />
-       <field field_ref="isig3"            name="isig3"   />
+       <field field_ref="sig1_pnorm"       name="sig1_pnorm"/>
+       <field field_ref="sig2_pnorm"       name="sig2_pnorm"/>
        
        <!-- heat fluxes -->
Index: /NEMO/trunk/cfgs/WED025/EXPREF/file_def_nemo-ice.xml
===================================================================
--- /NEMO/trunk/cfgs/WED025/EXPREF/file_def_nemo-ice.xml	(revision 13609)
+++ /NEMO/trunk/cfgs/WED025/EXPREF/file_def_nemo-ice.xml	(revision 13610)
@@ -50,7 +50,6 @@
        <field field_ref="normstr"          name="normstr" />
        <field field_ref="sheastr"          name="sheastr" />
-       <field field_ref="isig1"            name="isig1"   />
-       <field field_ref="isig2"            name="isig2"   />
-       <field field_ref="isig3"            name="isig3"   />
+       <field field_ref="sig1_pnorm"       name="sig1_pnorm"/>
+       <field field_ref="sig2_pnorm"       name="sig2_pnorm"/>
        
        <!-- heat fluxes -->